/* tslint:disable */
/* eslint-disable */
/**
*/
export function start(): void;
/**
* Compute the Keccak256 hash of a value.
* @param {any} message
* @returns {any}
*/
export function keccak256(message: any): any;
/**
* @returns {any}
*/
export function li17_p1_key_gen1(): any;
/**
* @param {any} context
* @param {any} msg
* @returns {any}
*/
export function li17_p1_key_gen2(context: any, msg: any): any;
/**
* @param {any} message
* @returns {any}
*/
export function li17_p2_key_gen1(message: any): any;
/**
* @param {any} context
* @param {any} msg
* @returns {any}
*/
export function li17_p2_key_gen2(context: any, msg: any): any;
/**
* @param {any} context
* @param {any} message_hash
* @returns {any}
*/
export function li17_p2_sign1(context: any, message_hash: any): any;
/**
* @param {any} context
* @param {any} msg
* @returns {any}
*/
export function li17_p2_sign2(context: any, msg: any): any;
/**
* @param {any} context
* @param {any} msg
* @param {any} message_hash
* @returns {any}
*/
export function li17_p1_sign1(context: any, msg: any, message_hash: any): any;
/**
* @param {any} context
* @param {any} msg
* @returns {any}
*/
export function li17_p1_sign2(context: any, msg: any): any;
/**
* @param {any} sign_context
* @returns {any}
*/
export function li17_p1_refresh1(sign_context: any): any;
/**
* @param {any} sign_context
* @param {any} msg
* @returns {any}
*/
export function li17_p1_refresh2(sign_context: any, msg: any): any;
/**
* @param {any} sign_context
* @param {any} msg
* @returns {any}
*/
export function li17_p2_refresh1(sign_context: any, msg: any): any;

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly start: () => void;
  readonly keccak256: (a: number, b: number) => void;
  readonly li17_p1_key_gen1: (a: number) => void;
  readonly li17_p1_key_gen2: (a: number, b: number, c: number) => void;
  readonly li17_p2_key_gen1: (a: number, b: number) => void;
  readonly li17_p2_key_gen2: (a: number, b: number, c: number) => void;
  readonly li17_p2_sign1: (a: number, b: number, c: number) => void;
  readonly li17_p2_sign2: (a: number, b: number, c: number) => void;
  readonly li17_p1_sign1: (a: number, b: number, c: number, d: number) => void;
  readonly li17_p1_sign2: (a: number, b: number, c: number) => void;
  readonly li17_p1_refresh1: (a: number, b: number) => void;
  readonly li17_p1_refresh2: (a: number, b: number, c: number) => void;
  readonly li17_p2_refresh1: (a: number, b: number, c: number) => void;
  readonly rustsecp256k1_v0_4_1_context_create: (a: number) => number;
  readonly rustsecp256k1_v0_4_1_context_destroy: (a: number) => void;
  readonly rustsecp256k1_v0_4_1_default_illegal_callback_fn: (a: number, b: number) => void;
  readonly rustsecp256k1_v0_4_1_default_error_callback_fn: (a: number, b: number) => void;
  readonly __wbindgen_malloc: (a: number) => number;
  readonly __wbindgen_realloc: (a: number, b: number, c: number) => number;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_free: (a: number, b: number) => void;
  readonly __wbindgen_exn_store: (a: number) => void;
  readonly __wbindgen_start: () => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {SyncInitInput} module
*
* @returns {InitOutput}
*/
export function initSync(module: SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
